// MSC2SampleDlg.cpp
//

#include "stdafx.h"
#include <conio.h>
#include <strstrea.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include "MSC2Sample.h"
#include "MSC2SampleDlg.h"
#include "MscCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CMscCtrl msc;				// Contrller MSC
/////////////////////////////////////////////////////////////////////////////
//  CAboutDlg Dialog

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Support DDX/DDV
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMSC2SampleDlg Dialog

CMSC2SampleDlg::CMSC2SampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMSC2SampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMSC2SampleDlg)
	m_strAx1Move = _T("");
	m_strAx2Move = _T("");
	m_sytAX1Now = _T("");
	m_strAX2Now = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMSC2SampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMSC2SampleDlg)
	DDX_Control(pDX, IDC_EDPOS, m_strPos);
	DDX_Control(pDX, IDC_EDMES, m_strMes);
	DDX_Text(pDX, IDC_EDAX1MOV, m_strAx1Move);
	DDX_Text(pDX, IDC_EDAX2MOV, m_strAx2Move);
	DDX_Text(pDX, IDC_EDAX1NOW, m_sytAX1Now);
	DDX_Text(pDX, IDC_EDAX2NOW, m_strAX2Now);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMSC2SampleDlg, CDialog)
	//{{AFX_MSG_MAP(CMSC2SampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTAX1ABS, OnBtax1abs)
	ON_BN_CLICKED(IDC_BTAX1RELM, OnBtax1relm)
	ON_BN_CLICKED(IDC_BTAX1RELP, OnBtax1relp)
	ON_BN_CLICKED(IDC_BTAX2ABS, OnBtax2abs)
	ON_BN_CLICKED(IDC_BTAX2ORG, OnBtax2org)
	ON_BN_CLICKED(IDC_BTAX2RELM, OnBtax2relm)
	ON_BN_CLICKED(IDC_BTAX2RELP, OnBtax2relp)
	ON_BN_CLICKED(IDC_BTAX1ORG, OnBtax1org)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMSC2SampleDlg message handller

BOOL CMSC2SampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "Version information" 

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// large icon
	SetIcon(m_hIcon, FALSE);		// small icon
	
	if( msc.RS_Setup() ) { 
		MessageBox( "Can not open COM1 port.","Error", MB_OK | MB_ICONQUESTION );
		return FALSE;
	}
	m_bProcess = FALSE;
	m_wTimerID = CWnd::SetTimer(1, 1000, NULL); 
	
	return TRUE;
}

void CMSC2SampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


void CMSC2SampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Device context

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CMSC2SampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// -------------------------------------------------------------------
//		motor status check
//
void CMSC2SampleDlg::OnTimer(UINT nIDEvent) 
{
	CString	strMess;					// Display message
	if( m_bProcess == FALSE ){			// No access between Stage moving.
		if( msc.MscPos() == 0 ) {		// Get current position.
			sprintf( strMess.GetBuffer(50), "Position:%s", msc.m_strResp );
			m_strPos.SetWindowText( strMess );
			WriteEditFloat( IDC_EDAX1NOW, msc.m_fAValue );	// A axis current position
			WriteEditFloat( IDC_EDAX2NOW, msc.m_fBValue );	// B axis current position
		}
		Sleep(100);
		msc.MscSensor( );				// Get sensor status.
		sprintf( strMess.GetBuffer(50), "Sensor:%s", msc.m_strResp );
		m_strMes.SetWindowText( strMess );
		if( msc.m_bALimitPlus ) CheckRadioButton( IDC_RDAX1CWS, IDC_RDAX1CWS, IDC_RDAX1CWS );
		else  CheckRadioButton( IDC_RDAX1CWS, IDC_RDAX1CWS, 0 );
		if( msc.m_bALimitMinus ) CheckRadioButton( IDC_RDAX1CCWS, IDC_RDAX1CCWS, IDC_RDAX1CCWS );
		else CheckRadioButton( IDC_RDAX1CCWS, IDC_RDAX1CCWS, 0 );
		if( msc.m_bABeforeOrigin ) CheckRadioButton( IDC_RDAX1BORGS, IDC_RDAX1BORGS, IDC_RDAX1BORGS );
		else CheckRadioButton( IDC_RDAX1BORGS, IDC_RDAX1BORGS, 0 );
		if( msc.m_bAOrigin ) CheckRadioButton( IDC_RDAX1ORGS, IDC_RDAX1ORGS, IDC_RDAX1ORGS );
		else CheckRadioButton( IDC_RDAX1ORGS, IDC_RDAX1ORGS, 0 );

		if( msc.m_bBLimitPlus ) CheckRadioButton( IDC_RDAX2CWS, IDC_RDAX2CWS, IDC_RDAX2CWS );
		else CheckRadioButton( IDC_RDAX2CWS, IDC_RDAX2CWS, 0 );
		if( msc.m_bBLimitMinus ) CheckRadioButton( IDC_RDAX2CCWS, IDC_RDAX2CCWS, IDC_RDAX2CCWS );
		else CheckRadioButton( IDC_RDAX2CCWS, IDC_RDAX2CCWS, 0 );
		if( msc.m_bBBeforeOrigin ) CheckRadioButton( IDC_RDAX2BORGS, IDC_RDAX2BORGS, IDC_RDAX2BORGS );
		else CheckRadioButton( IDC_RDAX2BORGS, IDC_RDAX2BORGS, 0 );
		if( msc.m_bBOrigin ) CheckRadioButton( IDC_RDAX2ORGS, IDC_RDAX2ORGS, IDC_RDAX2ORGS );
		else CheckRadioButton( IDC_RDAX2ORGS, IDC_RDAX2ORGS, 0 );
	}
}

// -------------------------------------------------------------------
//		Text box conversion float Value
//		return:
//			TRUE  = Normal
//			FALSE = Abnormal
BOOL CMSC2SampleDlg::GetEditFloat( int nID, float &val )
{
	char	str[ 20 ];
	int		nDot = 0,							// Period number
			nDef = 0;							// Signe number
	int nSize = GetDlgItemText( nID, str, 19 );	// Strings get to text box

	for( int i = 0; i < nSize; i++ ){
		if( isdigit( str[i] ) )					// 0`9
			continue;
		else if( str[i] == '.' )				// Period
			nDot++;
		else if( (str[i] != '-') && (str[i] != '+') )
			nDef++;
	}		
	if( (nDot > 1) || (nSize == 0) || (nDef > 0) ){
		CWnd::MessageBox( " Invalid value.", "WARNING", MB_OK | MB_ICONEXCLAMATION );
		return FALSE;
	}
	str[ nSize ] = '\0';
	char* endptr;
	double d = strtod( str, &endptr );
	val = float( d );
	return TRUE;
}

//
//		Float value display to text box
//
void CMSC2SampleDlg::WriteEditFloat( int nID, float val )
{

	char	str[ 20 ];

	ostrstream cnv( str, 20 );
	cnv.flags( ios::fixed );
	cnv.precision( 0 );
	cnv << val << '\0';
	SetDlgItemText( nID, str );
}

///////////////////////////////////////////
// Stage moving process.
///////////////////////////////////////////

//
// ORG button to axis 1 ( Moving origin.)
//
void CMSC2SampleDlg::OnBtax1org() 
{
	m_bProcess = TRUE;
	msc.Origin( 1 );
	m_bProcess = FALSE;
}

//
// ABS button to axis 1 ( Moving absolute for set value.)
//
void CMSC2SampleDlg::OnBtax1abs() 
{
	float fMov;
	m_bProcess = TRUE;
	if( GetEditFloat( IDC_EDAX1MOV, fMov ) == FALSE ) return;
	msc.Absolute( 1, fMov );
	m_bProcess = FALSE;
}

//
// REL minus button to axis 1 ( Moving relative minus for set value.)
//
void CMSC2SampleDlg::OnBtax1relm() 
{
	float fMov;
	m_bProcess = TRUE;
	if( GetEditFloat( IDC_EDAX1MOV, fMov ) == FALSE ) return;
	msc.RelativeM( 1, fMov );
	m_bProcess = FALSE;
}

//
// REL plus button to axis 1 ( Moving relative plus for set value.)
//
void CMSC2SampleDlg::OnBtax1relp() 
{
	float fMov;
	m_bProcess = TRUE;
	if( GetEditFloat( IDC_EDAX1MOV, fMov ) == FALSE ) return;
	msc.RelativeP( 1, fMov );
	m_bProcess = FALSE;
}

//
// ORG button to axis 2 ( Moving origin.)
//
void CMSC2SampleDlg::OnBtax2org() 
{
	m_bProcess = TRUE;
	msc.Origin( 2 );
	m_bProcess = FALSE;
}

//
// ABS button to axis 2 ( Moving absolute for set value.)
//
void CMSC2SampleDlg::OnBtax2abs() 
{
	float fMov;
	m_bProcess = TRUE;
	if( GetEditFloat( IDC_EDAX2MOV, fMov ) == FALSE ) return;
	msc.Absolute( 2, fMov );
	m_bProcess = FALSE;

}


//
// REL minus button to axis 2 ( Moving relative minus for set value.)
//
void CMSC2SampleDlg::OnBtax2relm() 
{
	float fMov;
	m_bProcess = TRUE;
	if( GetEditFloat( IDC_EDAX2MOV, fMov ) == FALSE ) return;
	msc.RelativeM( 2, fMov );
	m_bProcess = FALSE;
}

//
// REL plus button to axis 2 ( Moving relative plus for set value.)
//
void CMSC2SampleDlg::OnBtax2relp() 
{
	float fMov;
	m_bProcess = TRUE;
	if( GetEditFloat( IDC_EDAX2MOV, fMov ) == FALSE ) return;
	msc.RelativeP( 2, fMov );
	m_bProcess = FALSE;
}


//
// Program finish.
//
void CMSC2SampleDlg::OnOK() 
{
	msc.RS_Reset();
	CDialog::OnOK();
}
